-- bibler.e
-- routines for accessing EUPHORIA Database Bibles
-- cklester
-- Release Date: September 26, 2003

-- PLEASE send any bug reports, bug fixes, or enhancements to
-- me at my email address: euphoric@cklester.com

-- THANKS!!! (And God Bless You!) ;)

sequence bible_version, bibles
atom opens

bible_version = "bible-kjv.edb" -- default version
bibles = {} -- list of opened bibles
opens = 0

global function Bible()
	return bible_version
end function

global function OpenBible(sequence bible_name)
object junk, db
	if find( bible_name , bibles ) then
		db = db_select( bible_name )
		bible_version = bible_name
	else
		db = db_open( bible_name, DB_LOCK_NO )
		if db = DB_OK then
			bibles = append(bibles, bible_name)
			bible_version = bible_name
		end if
	end if
	return db
end function

global procedure CloseBible(sequence bible_name)
object db
	if find(bible_name, bibles) then
		db = db_select(bible_name)
		db_close()
	end if
end procedure

global function get_book_list()
atom tab, recs
sequence rec, booklist
object db
	booklist = {}
	db = OpenBible( bible_version )
	if db=DB_OK then
		tab = db_select_table("BOOKS")
		if db=DB_OK then
			recs = db_table_size()
			for t=1 to recs do
				rec = db_record_data( t )
				booklist = append(booklist,rec[1])
			end for
		end if
	end if
	return booklist
end function

global function get_chapter_list(atom book)
integer chapter, verse
atom i, table
object key1, db
sequence key, chapterlist
	chapterlist = {}
	-- get the chapters and verses per chapter
	db = OpenBible(bible_version)
	if db =DB_OK then
		chapter = 1
		verse = 1
		key = book & chapter & verse
		table = db_select_table("VERSE_TEXT")
		if db=DB_OK then
			while 1 do
				i = db_find_key( key )
				if i > 0 then
					-- found it
					chapterlist = append(chapterlist,sprintf("%d", {chapter} ))
					chapter = chapter + 1
				else
					exit
				end if
				key = book & chapter & verse
			end while
		end if
	end if
	return chapterlist
end function

global function get_verse_list(atom book, atom chapter)
integer verse
atom i, table
sequence key, verselist
object db
	verselist = {}
	
	db = OpenBible(bible_version)

	if db=DB_OK then
		verse = 1
		key = book & chapter & verse
		table = db_select_table("VERSE_TEXT")
		if table=DB_OK then
			while 1 do
				i = db_find_key( key )
				if i > 0 then
					verselist = append(verselist,sprintf("%d", {verse} ) )
					verse += 1
				else
					exit
				end if
				key = book & chapter & verse
			end while
		end if
	end if
	return verselist
end function

global function find_book(sequence book)
object junk, db
	db = OpenBible(bible_version)
	if db=DB_OK then
		db = db_select_table("BOOKS")
		if db=DB_OK then
			for t=1 to db_table_size() do
				junk = db_record_data(t)
				if equal(junk[1],book) then
					return t
				end if
			end for
		end if
	end if
	return -1
end function

global function book_name( atom bookn )
object db
	db = OpenBible(bible_version)
	if db = DB_OK then
		db = db_select_table("BOOKS")
		if db=DB_OK then
			db = db_find_key( bookn )
			if db > 0 then
				db = db_record_data( db )
				return db[1]
			end if
		end if
	end if
	return ""
end function

global function get_verse(atom book, atom chapter, atom verse)
object junk, db
	junk = ""
	db = OpenBible(bible_version)
	if db=DB_OK then
		db = db_select_table("VERSE_TEXT")
		if db=DB_OK then
			junk = db_find_key( {book,chapter,verse})
			if junk > 0 then
				junk = db_record_data( junk )
				junk = junk[1]
			else
				junk = "NO SUCH VERSE"
			end if
		else
			junk = "Couldn't select VERSE_TEXT"
		end if
	else
		junk = "get_verse() couldn't open " & bible_version & "."
	end if
	return junk
end function

global function get_verses(atom bookn, sequence verses)
object result, junk, db
sequence list
atom chapter, start, ending

	-- first, find field_name in the _FIELDS table
	-- where _FIELDS is a list of the fields in table FIELDS
	-- look up book in books table
	result = {}
	if bookn > 0 then
		db = OpenBible(bible_version)
		if db=DB_OK then
			junk = db_select_table("VERSE_TEXT")
			if junk = DB_OK then
				chapter = verses[1]
				start = 1
				for t=1 to length(verses[2]) do
					if verses[2][t] < 0 then -- it's the end of a series
						ending = -verses[2][t]
						if start = 1 then -- from first verse
							for tt=1 to ending do
								junk = db_find_key( {bookn,chapter,tt})
								if junk > 0 then
									junk = db_record_data( junk )
									junk = junk[1]
								else
									junk = "NO SUCH VERSE"
								end if
								result = append(result, sprintf("[%d] ",{tt}) & junk)
								--result = append(result, sprintf("[%d] ",{tt}) & get_verse(bookn,chapter,tt))
							end for
						else -- from verse at start
							for tt=start to ending do
								junk = db_find_key( {bookn,chapter,tt})
								if junk > 0 then
									junk = db_record_data( junk )
									junk = junk[1]
								else
									junk = "NO SUCH VERSE"
								end if
								result = append(result, sprintf("[%d] ",{tt}) & junk)
								--result = append(result, sprintf("[%d] ",{tt}) & get_verse(bookn,chapter,tt))
							end for
						end if
					else -- it's the start of a series or standalone
						start = verses[2][t]
						-- add to list
						-- if it's a stand alone, add it now
						if length(verses[2]) > t then
							if verses[2][t+1] > 0 then -- it's a stand alone
								result = append(result, sprintf("[%d] ",{start}) & get_verse(bookn,chapter,start))
							end if
						else
							result = append(result, sprintf("[%d] ",{start}) & get_verse(bookn,chapter,start))
						end if
					end if
				end for
			else
				result = "COULD NOT OPEN TABLE VERSE_TEXT!"
			end if
		else
			result = "get_verses() COULD NOT OPEN " & bible_version & "."
		end if
	end if
	return result
end function

global function get_favorite_verses()
object db, rec
atom recs
sequence faves
	faves = {}
	db = db_open("bible_faves.edb", DB_LOCK_NO)
	if db != DB_OK then
		db = db_create("bible_faves.edb", DB_LOCK_NO)
		db = db_create_table("quotes")
	else
		db = db_select_table("quotes")
		recs = db_table_size()
		if recs > 0 then
			for t=1 to recs do
				rec = db_record_key( t )
				faves = append(faves,rec)
			end for
		end if
	end if
	db_close()
	return faves
end function

global function get_favorite_key(atom vnum)
object db, rec
atom recs
	db = db_open("bible_faves.edb", DB_LOCK_NO)
	if db != DB_OK then
		db = db_create("bible_faves.edb", DB_LOCK_NO)
		db = db_create_table("quotes")
	else
		db = db_select_table("quotes")
		recs = db_table_size()
		if vnum > 0 and vnum <= recs then
			rec = db_record_key( vnum )
		end if
	end if
	db_close()
	return rec
end function
